dendrocoord <- function( clust,
  horizontal = FALSE,
  nprune = -400, stemtype="none", stemlength=0,
  f = identity )
{
  N <- clust$dim[3] # number of items
  stemtype.i <-  pmatch(stemtype,c("none","relative","absolute","score"),nomatch=0)-1
  if( stemtype.i < 0 ) stop(paste0("unrecognized stemtype value: `",stemtype,"`"))
  r <- .C("dendrocoord",
    U=as.integer(clust$U),
    L=as.integer(clust$L),
    R=as.integer(clust$R),
    S=as.double(clust$S),
    leftmost=as.integer(clust$leftmost),
    n=as.integer(clust$n),
    nprune=as.integer(
      max(1,min(N,ifelse(nprune < 0,N/-nprune,nprune)))),
    stemtype=as.integer(stemtype.i),
    stemlength=as.double(stemlength),
    x=double(2*3*(N-1) + N),
    y=double(2*3*(N-1) + N),
    npoints=integer(1))

  if( horizontal )
    xy <- list(y=r$x[1:r$npoints], x= f(r$y[1:r$npoints]) )
  else
    xy <- list(x=r$x[1:r$npoints], y= f(r$y[1:r$npoints]) )

  xy
}
