\name{ng_hm1}
\alias{ng_hm1}
\title{Heatmap of one matrix}
\description{Cluster and show heatmap of one data matrix}
\usage{
ng_hm1(
  x,
  rclust=NULL, cclust=NULL,
  clust=NULL,
  rwa=NULL,rwb=NULL,
  cwa=NULL,cwb=NULL,
  rlab=NULL,col.rlab=NULL,rlab.text=NULL,
  clab=NULL,col.clab=NULL,clab.text=NULL,
  rdend.space=5, cdend.space=4,
  saturation = 2)
}
\arguments{
  \item{x}{Data matrix}
  \item{rclust,cclust}{Row and column clustering objects, as produced
    by \code{nnc}}
  \item{clust}{A list with two members: \code{rclust} and \code{cclust}}
  \item{rwa,rwb,cwa,cwb}{Row and column windows boundaries measured in
    ordering indices. The automatic values are \code{rwa=1}, \code{rwb=nrow(x)},
  \code{cwa=1} and \code{cwb=ncol(x)}. Supplied values are clipped to
  be within these default ranges.}
  \item{rlab,clab}{Row and column labels, as specified for \code{ng_label}}
  \item{col.rlab,col.clab}{Color for \code{rlab} and \code{clab}}
  \item{rlab.text,clab.text}{Vector of entire label; otherwise the row
    and column names of the matrix will be used. It is assumed to
  have the same ordering as the data matrix \code{x}}
  \item{rdend.space,cdend.space}{the space for row and column dendograms,
    in centimeters}
  \item{saturation}{Color saturation, see \code{ng_heatmap}}
}
\details{
  Given a data matrix, perform clustering of rows and columns. If either
  \code{rclust}, \code{cclust} and/or \code{clust} are specified, the
  supplied clustering objects are used instead. \code{clust} option
  overrides the other two. The function returns a list with
  \code{rclust} and \code{cclust} as members, and can be used
  in subsequent calls to this function.
}
\value{
  A list of two clustering objects (as produced by \code{nnc}), with
  two elements: \code{rclust} and \code{cclust}.
}
